#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const int MAXC = 1'000'000'000;

ll euclid(ll a, ll b, ll& c, ll& d) {
	if (b == 0) {
		c = 1;
		d = 0;
		return a;
	}
	ll e, f;
	ll ret = euclid(b, a % b, e, f);
	// b * e + (a % b) * f = ret
	// a * c + b * d = (a % b) * c + (a / b * b) * c + b * d
	d = e - (a / b * f);
	c = f;
	return ret;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	ll x1, y1;
	while (true) {
		x1 = rnd.next(MAXC, MAXC * 2);
		y1 = rnd.next(MAXC, MAXC * 2);
		if (__gcd(x1, y1) == 1) {
			break;
		}
	}

	ll x2, y2;
	euclid(x1, y1, x2, y2);
	assert(x1 * x2 + y1 * y2 == 1);

	cout << "3\n";
	cout << -MAXC << " " << -MAXC << "\n";
	cout << -MAXC + x1 << " " << -MAXC + y1 << "\n";
	ll x = -MAXC + (-y2);
	ll y = -MAXC + x2;
	while (x < -MAXC || y < -MAXC) {
		x += x1; y += y1;
	}
	cout << x << " " << y << "\n";

	return 0;
}