#include "testlib.h"
#include <set>
#include <vector>
#include <iostream>

using namespace std;

int maxx = (int)1e9;

pair<int, int> mas[(int)2e5 + 10];

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    cout << n << "\n";
    set<int> se;
    while ((int)se.size() < m)
    {
    	int x = rnd.next(-maxx, maxx);
    	se.insert(x);
    }
    vector<int> arr;
    for (int x: se)
    	arr.push_back(x);
    for (int i = 0; i < n; i++)
    {
    	int l = rnd.next(0, m - 1);
    	int r = rnd.next(0, m - 1);
    	while (l == r)
    	{
    		l = rnd.next(0, m - 1);
    		r = rnd.next(0, m - 1);
    	}
    	if (l > r)
    		swap(l, r);
    	mas[i] = {arr[l], arr[r]};
    }
    for (int i = 0; i < n; i++)
    	cout << mas[i].first << " " << mas[i].second << "\n";
    return 0;
}