#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const int MAXV = 1000000000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	vector<int> sieve(MAXV + 1);
	ll best = 0;
	pii ans = {0, 0};
	int prev = 0;
	set<int> have;
	const int SZ = 10;
	vector<pair<ll, pii>> vars;
	for (int i = 2; i <= MAXV; ++i) {
		if (!sieve[i]) {
			for (int j = i; j <= MAXV; j += i) {
				sieve[j] = i;
			}
			have.clear();
			for (int j = prev; j < i; ++j) {
				int tmp = j;
				while (tmp > 1) {
					int p = sieve[tmp];
					have.insert(p);
					tmp /= p;
				}
			}

			int from = -1;
			int pp = -1;
			int worst = 0, mem = 0;
			for (int p : have) {
				if (from == -1) {
					from = p - 1;
					while (from > 1 && sieve[from] != from) {
						--from;
					}
					pp = p;
					continue;
				}
				bool ok = true;
				for (int j = pp + 1; j < p; ++j) {
					if (sieve[j] == j) {
						ok = false;
						break;
					}
				}
				if (ok) {
					pp = p;
					continue;
				}
				int last = pp;
				while (last < MAXV && sieve[last + 1] != last + 1) {
					++last;
				}
				int val = last - from + 1;
				
				ll gval = (i - prev) * val;

				if (last > 1e8 && i - 1 > 1e8 && (szof(vars) < SZ || vars.back().ff < gval)) {
					cerr << gval << " " << last << " " << i - 1 << endl;
					vars.push_back({gval, {last, i - 1}});
					sort(vars.rbegin(), vars.rend());
					if (szof(vars) > SZ) {
						vars.resize(SZ);
					}
				}

				from = p - 1;
				while (from > 1 && sieve[from] != from) {
					--from;
				}
				pp = p;
			}
			prev = i;
		}
	}

	for (auto p : vars) {
		cerr << p.ff << " " << p.ss.ff << " " << p.ss.ss << endl;
	}

	return 0;
}