#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

ll smart(vector <int> a, vector <pair <int, int> > segs) {
  int n = (int) a.size();
  vector <ll> cnt(a.size());
  for (auto c : segs) {
    for (int i = c.first; i <= c.second; i++) {
      cnt[i]++;
    }
  }
  sort(a.begin(), a.end());
  ll value = 0;
  vector <bool> vis(n);
  while (!a.empty()) {
    int x = 0;
    for (int i = 0; i < n; i++) if (!vis[i]) x = i;
    for (int i = 0; i < n; i++) {
      if (cnt[i] > cnt[x] && !vis[i]) {
        x = i;
      }
    }
    vis[x] = true;
    value += cnt[x] * a.back();
    a.pop_back();
    vector <pair <int, int> > now;
    for (auto c : segs) {
      if (c.second < x || c.first > x) {
        now.push_back(c);
      } else {
        for (int i = c.first; i <= c.second; i++) {
          cnt[i]--;
        }
      }
    }
    segs = now;
  }
  return value;
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  int q;
  cin >> q;
  vector <pair <int, int> > e;
  for (int i = 0; i < q; i++) {
    int l, r;
    cin >> l >> r;
    l--, r--;
    e.push_back({l, r});
  }
  for (int i = 0; i < m; i++) {
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
      cin >> a[i];
    }
    cout << smart(a, e) << '\n';
  }
}
