#include "testlib.h"
#include <set>
using namespace std;

const long long MAXN = 100'000;
const long long MAXXY = 1'000'000'000;
const long long MINN = 3;

set<pair<long long, long long> > mas;

int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    long long n = inf.readLong(MINN, MAXN, "n");
    inf.readEoln();
    for (int i = 0; i < n; i++) {
        long long a = inf.readLong(-MAXXY, MAXXY, "mas");
        inf.readSpace();
        long long b = inf.readLong(-MAXXY, MAXXY, "mas");
        mas.insert({a, b});
        inf.readEoln();
    }
    ensuref(mas.size() == n, "points coincide");
    inf.readEof();
    return 0;
}