#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > graph;
vector<long long> power;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, a ,b;
    cin >> n;
    power.resize(n);
    graph.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> power[i];
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> a >> b;
        graph[a - 1].push_back(b - 1);
        graph[b - 1].push_back(a - 1);
    }
    long double l = 0;
    long double r = 1'000'000'000'000ll;
    while(true) {
        long double m = (l + r) / 2;
        if (r - l < 1e-6) {
            break;
        }
        long double sum = 0;
        int amount = 1;
        long long maxi = 0;
        for (int i = 0; i < n; i++) {
            sum = power[i];
            amount = 1;
            maxi = 0;
            for (auto j : graph[i]) {
                maxi = max(maxi, power[j]);
                if (power[j] >= m) {
                    sum += power[j];
                    amount++;
                }
            }
            if ((amount > 1 && sum / amount >= m) || (amount == 1 && (sum + maxi) / (amount + 1) >= m))  {
                break;
            }
        }
        if (amount > 1 && sum / amount >= m) {
            l = sum / amount;
        } else if ((amount == 1 &&(sum + maxi) / (amount + 1) >= m)) {
            l = (sum + maxi) / (amount + 1);
        } else {
            r = m;
        }
    }
    cout.precision(20);
    cout << l << endl;
    return 0;
}