#include "testlib.h"
using namespace std;
const char COLORS[] = { 'R', 'Y', 'B' };
int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	int type = atoi(argv[1]);
	int n = atoi(argv[2]);
	string s(n, 'R'), t(n, 'R');
	if (type == 0)
	{
		for (int i = 0; i < n; ++i)
			s[i] = COLORS[rnd.next(3)];
		for (int i = 0; i < n; ++i)
			t[i] = COLORS[rnd.next(3)];
	}
	else if (type == 1)
	{
		int n = atoi(argv[2]);
		for (int i = 0; i < n; ++i)
			s[i] = COLORS[rnd.next(3)];
		for (int i = 0; i < n; ++i)
			do
				t[i] = COLORS[rnd.next(3)];
			while (t[i] == s[i]);
	}
	else if (type == 2)
	{
	    int coloring = atoi(argv[3]);
	    char color1 = COLORS[coloring % 3];
	    char color2 = COLORS[coloring / 3 % 3];
		for (int i = 0; i < n; ++i)
				if (i & 1)
					s[i] = color2;
				else
					s[i] = color1;
		t = s;
	}
	else if (type == 3)
	{
	    int coloring = atoi(argv[3]);
	    char color1 = COLORS[coloring % 3];
	    char color2 = COLORS[coloring / 3 % 3];
		for (int i = 0; i < n; ++i)
				if (i & 1)
					s[i] = color2;
				else
					s[i] = color1;
		t = s;
		for (int i = 0; i < n; ++i)
				if (i & 1)
					s[i] = color2;
				else
					s[i] = color1;
		for (int i = 0; i < n; ++i)
			t[i] = COLORS[rnd.next(3)];
		if (rnd.next(2))
			swap(s, t);
	}
	else if (type == 4)
	{
		char color1 = COLORS[rnd.next(3)];
		char color2;
		do
			color2 = COLORS[rnd.next(3)];
		while (color1 == color2);
		char color3 = COLORS[rnd.next(3)];
		char color4;
		do
			color4 = COLORS[rnd.next(3)];
		while (color3 == color4);
		for (int i = 0; i < n; ++i)
		{
			if (rnd.next(2))
				s[i] = color2;
			else
				s[i] = color1;
			if (rnd.next(2))
				t[i] = color4;
			else
				t[i] = color3;
		}
	}
	else if (type == 5)
	{
		n -= n % 3;
		s.resize(n);
		t.resize(n);
		for (int i = 0; i < n; ++i)
		{
			s[i] = COLORS[i % 3];
			t[i] = COLORS[(i + 1) % 3];
		}
	}
	cout << n << '\n' << s << '\n' << t << '\n';
}