// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif


void solve() {
	int n;
	cin >> n;
	vector<ll> arr;
	map<int, ll> vals;
	auto get_val = [&](int num) {
		if (!vals.count(num)) {
			vals[num] = tw();
		}
		return vals[num];
	};
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		arr.push_back(get_val(l) ^ get_val(r));
	}

	ll ans = 0;
	map<ll, int> cnt;
	ll cur = 0;
	for (int i = 0; i < n; ++i) {
		cnt[cur]++;
		cur ^= arr[i];
		ans += cnt[cur];
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
