// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input<int>();
    vector<string> in(n);
    input_seq(ALL(in));

    vector<int> cnt(10);
    for (string& s: in) {
        sort(ALL(s));
        s.erase(std::unique(ALL(s)), s.end());
        
        for (char ch: s)
            cnt[ch - '0'] += 1;
    }

    /*
    if (cnt[0] == 0) {
        cout << "0\n";
        return 0;
    }
    */
    
    int len = 1;
    while (cnt[0] >= len - 1 and *std::min_element(cnt.begin() + 1, cnt.end()) >= len)
        ++len;

    string res(len, '0');
    
    if (cnt[0] < len - 1) {
        res[0] = '1';
        cout << res << "\n";
        return 0;
    }

    int d = 1;
    while (cnt[d] >= len)
        ++d;

    int ntogether = 0;
    for (int i = 0; i < n; ++i)
        if (in[i][0] == '0' and std::count(ALL(in[i]), char('0' + d)))
            ++ntogether;

    // impossible to make "d0000"
    if (not (cnt[0] + cnt[d] - ntogether >= len))
        res[0] = '0' + d;
    else
        std::fill(ALL(res), '0' + d);

    cout << res << "\n";
    
    return 0;
}
