// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MAXN = 1005;

void solve() {
	vector<vector<ll>> dp(MAXN, vector<ll>(MAXN, INFL));
	dp[0][0] = 0;
	for (int i = 0; i < MAXN; ++i) {
		for (int j = 0; j < MAXN; ++j) {
			if (i == 0 && j == 0) {
				continue;
			}
			int val = __gcd(i, j);
			if (i) {
				dp[i][j] = dp[i - 1][j] + val;
			}
			if (j) {
				dp[i][j] = min(dp[i][j], dp[i][j - 1] + val);
			}
		}
	}
	
	int q = 1;
	for (int i = 0; i < q; ++i) {
		int a, b;
		cin >> a >> b;
		cout << dp[a][b] << "\n";
	}
	
	// cout << MAXN - 1 << " " << MAXN - 1 << "\n";
	// for (int i = 1; i < MAXN; ++i) {
	// 	for (int j = 1; j < MAXN; ++j) {
	// 		cout << (dp[i][j] == (i + j)) << " ";
	// 	}
	// 	cout << "\n";
	// }
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
