#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    long long sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }

    for (int i = 0; i < q; ++i) {
        int t, v;
        cin >> t >> v;
        if (t == 1) {
            a.push_back(v);
            sum += v;
        } else if (t == 2) {
            --v;
            sum -= a[v];
            a[v] = -1;
        } else {
            sum = 0;
            for (int j = 0; j < a.size(); ++j) {
                if (a[j] != -1) {
                    a[j] ^= v;
                    sum += a[j];
                }
            }
        }
        cout << sum << "\n";
    }

    return 0;
}